package de.zuim.ledcontrol.effects;

import java.awt.*;
import java.util.ArrayList;
import java.util.List;

import static de.zuim.ledcontrol.LEDControl.HEIGHT;
import static de.zuim.ledcontrol.LEDControl.WIDTH;

public class AudioVolumeEffect extends AudioFFTEffect {

	@Override
	public String getDescription() {
		return "Audio Volume";
	}

	List<Integer> volHistory = new ArrayList<>();
	long timeDeltaSum = 0;

	@Override
	public void render(long timeDelta, Graphics g) {
		timeDeltaSum += timeDelta;

		if (!getData().isEmpty()) {
			float avg = 0;
			for (double v : getData().get(0).magnitudes) {
				avg += Math.abs(v);
			}
			avg /= getData().get(0).magnitudes.length;
			volHistory.add((int) (((avg*-1)+40)/3));
			getData().clear();
		}

		if (volHistory.size() > WIDTH) {
			volHistory.remove(0);
		}

		for (int x = 0; x < volHistory.size(); x++) {
			g.setColor(new Color((int) ((Math.abs(volHistory.get(x)) + 1) * ((WIDTH - x) / (float) WIDTH)), 2, 0));
			g.drawRect(x, HEIGHT - volHistory.get(x), 0, HEIGHT);
		}
	}

}
